<?php
/*
* MBot Contact status check PHP Script [ANSI]
* Russian language
*  2011 Skurat Denis (a.k.a. Dionys)
* @contact: skiner@inbox.ru
* 
* Based on status.icq.com info
*/

/* CONFIGURATION */
define('SCRIPT_NAME',		'Contact status check');	// Script name.
define('SCRIPT_VERSION',	'1.0.0.1');					// Script version.
define('SYM_ENTER',			chr(0x0D).chr(0x0A));		// Enter symbols.
define('CHANGE_STATUS',		true);						// Change status in contact list.
define('ANSWER_ECHO',		false);						// Show server answer in mbot console.
/* END CONFIGURATION */

function mbot_load()
{
	if (MBOT_VERSION >= 0x01000000)
	{
		$icon = mb_IconLoadSys(IDI_INFORMATION);

		mb_SelfRegister(MB_EVENT_MENU_COMMAND, 1);
		mb_SelfSetInfo('    v.'.SCRIPT_VERSION.' by Dionys');
		mb_Echo('    v.'.SCRIPT_VERSION.' .'.SYM_ENTER);
		mb_MenuAdd('Contact status check', 0, 'ContactStatusCheckThread', $icon, 0x00, 1, 'ICQ', 0);
	}
	else
	{
		mb_echo(SCRIPT_NAME .': This scripts requires mBot 1.0.0.0 or later!');
	}
}

function ContactStatusCheckThread($param, $cid, $hmenu)
{
	mb_SysBeginThread('ContactStatusCheck', $cid);
}

function ContactStatusCheck($cid)
{
	$uin						= mb_CGetUIN($cid);
	$name						= mb_CIsOnList($cid) ? mb_CGetDisplayName($cid) : mb_CGetUIN($cid);
	if ($name == NULL) $name	= $uin;
	$host						= 'status.icq.com';
	$port						= 80;
	$path						= 'online.gif?icq='.$uin.'&img=5';
	$page						= get_page_info($host, $port, $path);
	$status						= substr($page, (strpos($page, '.gif') - 1), 1);

	if ($status != '0' && $status != '1' && $status != '2')
	{
		mb_PUAdd(NULL, '  ', '    : '.$host, 0, 0, mb_IconLoadSys(IDI_ERROR));
	}
	else
	{
		if ($status == '0' || $status == '1' || $status == '2')
		{
			switch($status)
			{
				case '0':
					$stext = '';
					break;
				case '1':
					$stext = '';
					break;
				case '2':
					$stext = '';
					break;
			}
		}

		mb_PUAdd(NULL, '  '.$name, '  : '.$stext, 0, 0, mb_IconLoadSys(IDI_INFORMATION));

		if (CHANGE_STATUS)
		{
			if ($status == '0' || $status == '1')
			{
				mb_CSettingAdd($cid, 'ICQ', DBVT_WORD, 'Status', 40072);
			}
			if ($status == '2')
			{
				mb_CSettingAdd($cid, 'ICQ', DBVT_WORD, 'Status', 40071);
			}
		}
	}
}

function get_page_info($host, $port, $path)
{
	$fp = @fsockopen ($host, $port, $errno, $errstr, 5); 

	if (!$fp)
	{
		mb_PUAdd(NULL, '   ($errno)', $errstr, 0, 0, mb_IconLoadSys(IDI_ERROR));
		return 'null';
	}
	else
	{
		$headers = 'GET /'. $path .' HTTP/1.0'. SYM_ENTER .'Host: '. $host . SYM_ENTER . SYM_ENTER;
		fwrite ($fp, $headers);
		while (!feof ($fp))
		{ 
			$str .= @fgets($fp, 1024);
		} 
		fclose($fp);

		if (ANSWER_ECHO)
		{
			mb_Echo('   .'. SYM_ENTER .' :'. SYM_ENTER . $str . SYM_ENTER .'* *'. SYM_ENTER);
		}
		
		if ($str == '')
		{
			return 'null';
		}
		else
		{
			return $str;
		}
	}
}
?>